----------------------------------------------------------
-- Edit pw.profile1.lua and pw.profile2.lua to change your settings.
----------------------------------------------------------


----------------------------------------------------------
-- Do not edit below this line unless you know what you are doing
----------------------------------------------------------

monsterList = { };

HP = 10000;
MaxHP = 10000;
MP = 10000;
MaxMP = 10000;

staticbase_ptr = 0x00903804;
staticbase_offset = 0x20;
charptr_addr = 0;
targetid_offset = 0xA18;

HP_offset = 1104;
MaxHP_offset = 1144;
MP_offset = 1108;
MaxMP_offset = 1148;


function buff1()
  keyboardPress(buff1_key);
  printf("%s\n", buff1_description);
end

function buff2()
  keyboardPress(buff2_key);
  printf("%s\n", buff2_description);
end

function buff3()
  keyboardPress(buff3_key);
  printf("%s\n", buff3_description);
end


function registerBuffs()
  if( buff1_time > 0 ) then registerTimer("buff1", buff1_time, buff1); end
  if( buff2_time > 0 ) then registerTimer("buff2", buff2_time, buff2); end
  if( buff3_time > 0 ) then registerTimer("buff3", buff3_time, buff3); end
end

function update_vars()
  HP = memoryReadIntPtr(proc, charptr_addr, HP_offset);
  MaxHP = memoryReadIntPtr(proc, charptr_addr, MaxHP_offset);
  MP = memoryReadIntPtr(proc, charptr_addr, MP_offset);
  MaxMP = memoryReadIntPtr(proc, charptr_addr, MaxMP_offset);
end

function use_hp_potion()
  keyboardPress(HP_potion_key);
  HP = HP + 10;
end

function use_mp_potion()
  keyboardPress(MP_potion_key);
  MP = MP + 10;
end

function sit()
  printf( os.date("Resting... %X\n") );
  keyboardPress(sit_key);
  local last_hp = HP;
  yrest(1000);

  while( true ) do
    -- sit there looking stupid.
    if( HP == MaxHP and MP == MaxMP ) then break; end;

    -- exiting rest disabled for now.
    if( HP < last_hp ) then printf("Exiting! Under attack."); break; end; -- exit rest if under attack

    last_hp = HP;
    yrest(100);
  end

  printf( os.date("Exiting rest. %X\n") );
  keyboardPress(sit_key);
end

function find_target()
  local i;
  local readval;

  printf("Finding target...");
  for i = 1, #monsterList do
    memoryWriteUIntPtr(proc, charptr_addr, targetid_offset, monsterList[i]);

    yrest(100);
    readval = memoryReadUIntPtr(proc, charptr_addr, targetid_offset);
    if( readval ~= 0 ) then
      printf(" OK!\n");
      return true;
    end

    coroutine.yield();
  end

  printf(" FAIL!\n");
  return false;
end


function have_target()
  local readval = memoryReadUIntPtr(proc, charptr_addr, targetid_offset);
  return (readval ~= 0);
end


function pickup_items()
  if( pickup_key == 0 ) then return; end

  local i;
  for i = 0, 5 do
    keyboardPress(pickup_key);
    yrest(200);
  end

  yrest(1000);
end


function fight()
  while( have_target() ) do
    keyboardPress(attack_key);

    if( (HP / MaxHP * 100) < HP_potion_use ) then use_hp_potion() end
    if( (MP / MaxMP * 100) < MP_potion_use ) then use_mp_potion() end

    yrest(1000);
  end

  pickup_items();
end

function get_monster_list()
  local lasthomepress = true;
  local lastinsertpress = true;
  local readval = 0;

  printf("Select a monster and press INSERT to add this specific monster to your attack list.\n");
  printf("When you are done creating your list (5 monsters should be fine) press HOME again.\n");
  while( true) do
    if( keyPressed(key.VK_HOME) and lasthomepress == false ) then break; end
    if( keyPressed(key.VK_HOME) == false ) then lasthomepress = false; end

    if( keyPressed(key.VK_INSERT) ) then
      if( lastinsertpress == false and have_target() ) then
        readval = memoryReadUIntPtr(proc, charptr_addr, targetid_offset);
        printf("Added monster [%x] to your attack list.\n", readval);
        table.insert(monsterList, readval);
      end
      lastinsertpress = true;
    else
      lastinsertpress = false;
    end

    yrest(100);
  end
end

function select_window(title)
  local list = findWindowList(title);

  local count = #list;
  if( count > 9 ) then count = 9; end

  if( count == 0 ) then return 0; end;
  if( count < 2 ) then
    return list[1];
  end

  printf("Select a window:\n");
  for i = 1, count do
    printf("  %d  : %s", i, getWindowName(list[i]));
  end

  local win = 0;
  while( win == 0 ) do
    for i = 1, count do
      if( keyPressed(key.VK_1 + i-1) ) then
        win = list[i];
      end
    end
    rest(100);
  end

  return win;
end

function select_profile()
  printf("Select a profile to use (this determines your settings)\n");
  printf("  1  : pw.profile1\n  2  : pw.profile2\n\n");

  local lastkey = true;
  while( 1 ) do
    if( keyPressed(key.VK_1) ) then
      if( lastkey == false ) then dofile("scripts/pw.profile1.lua"); break; end
      lastkey = true;
    elseif( keyPressed(key.VK_2) ) then
      if( lastkey == false ) then dofile("scripts/pw.profile2.lua"); break; end
      lastkey = true;
    else
      lastkey = false;
    end

    rest(100);
  end

end


function exit_callback()
  setWindowName(getHwnd(), "MicroMacro");
end

-- We want this done BEFORE asking the user to start the bot,
-- so it's put at global scope.
win = select_window("Element Client");
select_profile();

function main()
  local original_name = getWindowName(win);
  attach(win);
  proc = openProcess( findProcessByWindow(win) );
  setPriority(PRIORITY_HIGH);

  local winname = original_name .. " [ID:" .. sprintf("%x",win) .. "]";
  if( string.find(original_name, " [ID:" .. sprintf("%x",win) .. "]", 1, true) == nil ) then
    setWindowName(win, winname);
  end
  setWindowName(getHwnd(), "MicroMacro - " .. "Perfect World Bot" .. " [ID:" .. sprintf("%x",win) .. "]");

  atExit(exit_callback);

  charptr_addr = memoryReadInt(proc, staticbase_ptr) + staticbase_offset;

  get_monster_list();

  printf("\nBOT STARTED\n");

  registerTimer("update_vars", 100, update_vars);
  registerBuffs();

  while(1) do
    if( have_target() == false ) then
      find_target(); end

    if( have_target() ) then
      fight();
    end

    if( (HP / MaxHP * 100) < HP_sit and HP_sit > 0) then sit() end;
    if( (MP / MaxMP * 100) < MP_sit and MP_sit > 0) then sit() end;
    if( (HP / MaxHP * 100) < HP_potion_use and HP_potion_use > 0) then use_hp_potion() end
    if( (MP / MaxMP * 100) < MP_potion_use and MP_potion_use > 0) then use_mp_potion() end

    yrest(100);
  end
end

startMacro(main, true);